/*
 * Harbor API
 * These APIs provide services for manipulating Harbor project.
 *
 * OpenAPI spec version: 2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.19
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.HarborApi) {
      root.HarborApi = {};
    }
    root.HarborApi.Instance = factory(root.HarborApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The Instance model module.
   * @module model/Instance
   * @version 2.0
   */

  /**
   * Constructs a new <code>Instance</code>.
   * @alias module:model/Instance
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>Instance</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Instance} obj Optional instance to populate.
   * @return {module:model/Instance} The populated <code>Instance</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('description'))
        obj.description = ApiClient.convertToType(data['description'], 'String');
      if (data.hasOwnProperty('vendor'))
        obj.vendor = ApiClient.convertToType(data['vendor'], 'String');
      if (data.hasOwnProperty('endpoint'))
        obj.endpoint = ApiClient.convertToType(data['endpoint'], 'String');
      if (data.hasOwnProperty('auth_mode'))
        obj.authMode = ApiClient.convertToType(data['auth_mode'], 'String');
      if (data.hasOwnProperty('auth_info'))
        obj.authInfo = ApiClient.convertToType(data['auth_info'], {'String': 'String'});
      if (data.hasOwnProperty('status'))
        obj.status = ApiClient.convertToType(data['status'], 'String');
      if (data.hasOwnProperty('enabled'))
        obj.enabled = ApiClient.convertToType(data['enabled'], 'Boolean');
      if (data.hasOwnProperty('default'))
        obj._default = ApiClient.convertToType(data['default'], 'Boolean');
      if (data.hasOwnProperty('insecure'))
        obj.insecure = ApiClient.convertToType(data['insecure'], 'Boolean');
      if (data.hasOwnProperty('setup_timestamp'))
        obj.setupTimestamp = ApiClient.convertToType(data['setup_timestamp'], 'Number');
    }
    return obj;
  }

  /**
   * Unique ID
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Instance name
   * @member {String} name
   */
  exports.prototype.name = undefined;

  /**
   * Description of instance
   * @member {String} description
   */
  exports.prototype.description = undefined;

  /**
   * Based on which driver, identified by ID
   * @member {String} vendor
   */
  exports.prototype.vendor = undefined;

  /**
   * The service endpoint of this instance
   * @member {String} endpoint
   */
  exports.prototype.endpoint = undefined;

  /**
   * The authentication way supported
   * @member {String} authMode
   */
  exports.prototype.authMode = undefined;

  /**
   * The auth credential data if exists
   * @member {Object.<String, String>} authInfo
   */
  exports.prototype.authInfo = undefined;

  /**
   * The health status
   * @member {String} status
   */
  exports.prototype.status = undefined;

  /**
   * Whether the instance is activated or not
   * @member {Boolean} enabled
   */
  exports.prototype.enabled = undefined;

  /**
   * Whether the instance is default or not
   * @member {Boolean} _default
   */
  exports.prototype._default = undefined;

  /**
   * Whether the instance endpoint is insecure or not
   * @member {Boolean} insecure
   */
  exports.prototype.insecure = undefined;

  /**
   * The timestamp of instance setting up
   * @member {Number} setupTimestamp
   */
  exports.prototype.setupTimestamp = undefined;


  return exports;

}));
